/* ----------------------------------------------------------------------------
 * This file was automatically generated by SWIG (http://www.swig.org).
 * Version 4.0.2
 *
 * Do not make changes to this file unless you know what you are doing--modify
 * the SWIG interface file instead.
 * ----------------------------------------------------------------------------- */
package com.herumi.mcl

object ElgamalJNI {
    external fun new_p_bool(): Long
    external fun copy_p_bool(jarg1: Boolean): Long
    external fun delete_p_bool(jarg1: Long)
    external fun p_bool_assign(jarg1: Long, jarg2: Boolean)
    external fun p_bool_value(jarg1: Long): Boolean
    external fun SystemInit(jarg1: String?)
    external fun CipherText_toStr(jarg1: Long, jarg1_: CipherText?): String?
    external fun CipherText_toString(jarg1: Long, jarg1_: CipherText?): String?
    external fun CipherText_fromStr(jarg1: Long, jarg1_: CipherText?, jarg2: String?)
    external fun CipherText_add(jarg1: Long, jarg1_: CipherText?, jarg2: Long, jarg2_: CipherText?)
    external fun CipherText_mul__SWIG_0(jarg1: Long, jarg1_: CipherText?, jarg2: Int)
    external fun CipherText_mul__SWIG_1(jarg1: Long, jarg1_: CipherText?, jarg2: String?)
    external fun new_CipherText(): Long
    external fun delete_CipherText(jarg1: Long)
    external fun PublicKey_toStr(jarg1: Long, jarg1_: PublicKey?): String?
    external fun PublicKey_toString(jarg1: Long, jarg1_: PublicKey?): String?
    external fun PublicKey_fromStr(jarg1: Long, jarg1_: PublicKey?, jarg2: String?)
    external fun PublicKey_save(jarg1: Long, jarg1_: PublicKey?, jarg2: String?)
    external fun PublicKey_load(jarg1: Long, jarg1_: PublicKey?, jarg2: String?)
    external fun PublicKey_enc__SWIG_0(
        jarg1: Long,
        jarg1_: PublicKey?,
        jarg2: Long,
        jarg2_: CipherText?,
        jarg3: Int
    )

    external fun PublicKey_enc__SWIG_1(
        jarg1: Long,
        jarg1_: PublicKey?,
        jarg2: Long,
        jarg2_: CipherText?,
        jarg3: String?
    )

    external fun PublicKey_rerandomize(
        jarg1: Long,
        jarg1_: PublicKey?,
        jarg2: Long,
        jarg2_: CipherText?
    )

    external fun PublicKey_add__SWIG_0(
        jarg1: Long,
        jarg1_: PublicKey?,
        jarg2: Long,
        jarg2_: CipherText?,
        jarg3: Int
    )

    external fun PublicKey_add__SWIG_1(
        jarg1: Long,
        jarg1_: PublicKey?,
        jarg2: Long,
        jarg2_: CipherText?,
        jarg3: String?
    )

    external fun new_PublicKey(): Long
    external fun delete_PublicKey(jarg1: Long)
    external fun PrivateKey_toStr(jarg1: Long, jarg1_: PrivateKey?): String?
    external fun PrivateKey_toString(jarg1: Long, jarg1_: PrivateKey?): String?
    external fun PrivateKey_fromStr(jarg1: Long, jarg1_: PrivateKey?, jarg2: String?)
    external fun PrivateKey_save(jarg1: Long, jarg1_: PrivateKey?, jarg2: String?)
    external fun PrivateKey_load(jarg1: Long, jarg1_: PrivateKey?, jarg2: String?)
    external fun PrivateKey_init(jarg1: Long, jarg1_: PrivateKey?)
    external fun PrivateKey_getPublicKey(jarg1: Long, jarg1_: PrivateKey?): Long
    external fun PrivateKey_dec__SWIG_0(
        jarg1: Long,
        jarg1_: PrivateKey?,
        jarg2: Long,
        jarg2_: CipherText?,
        jarg3: Long
    ): Int

    external fun PrivateKey_dec__SWIG_1(
        jarg1: Long,
        jarg1_: PrivateKey?,
        jarg2: Long,
        jarg2_: CipherText?
    ): Int

    external fun PrivateKey_setCache(jarg1: Long, jarg1_: PrivateKey?, jarg2: Int, jarg3: Int)
    external fun PrivateKey_clearCache(jarg1: Long, jarg1_: PrivateKey?)
    external fun new_PrivateKey(): Long
    external fun delete_PrivateKey(jarg1: Long)
}